/* ald1r.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int ald1r_c(real *g, integer *mdg, integer *m, integer *n,
        real *h__, real *x, real *xnorm, real *w, integer *index,
        integer *ierr)
{
    /* Initialized data */

    static real zero = 0.f;
    static real one = 1.f;

    /* System generated locals */
    integer g_dim1, g_offset, i__1, i__2;
    real r__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    extern /* Subroutine */ int aln1r_c(real *, integer *, integer *, integer *
            , real *, real *, real *, real *, real *, integer *, integer *);
    static integer i__, j;
    extern real aln1r4_c(real *, real *);
    static real rnorm;
    static integer if__, iw, iy, iz, iwdual, np1;
    static real fac;


#define g_ref(a_1,a_2) g[(a_2)*g_dim1 + a_1]


/* ******************************************************* */

/*    PURPOSE: **** LEAST DISTANCE PROGRAMMING ********** */

/*  GIVEN AN M BY N  MATRIX  .G. AND  AN  M-VECTOR .H. */
/*  COMPUTE  AN  N-VECTOR .X.  WHICH SOLVES THE LEAST */
/*  SQUARES PROBLEM: */
/*          G * X >= H     SUBJECT TO //X// - MIN */

/*  SOURCE:LAWSON C.L.,HANSON R.J. 'SOLVING LEAST SQUARES */
/*  PROBLEM' , PRENTICE-HALL INC.,ENGLEWOOD CLIFFS,NEW */
/*  JERSEY, 1974. */

/*    PARAMETERS: */
/* G,MDG,M,N - MDG IS THE FIRST DIMENSIONING PARAMETER FOR */
/*             THE ARRAY .G( ).  ON ENTRY G( ) CONTAINS THE */
/*             M BY N MATRIX .G. */
/* H         - ON ENTRY H CONTAINS THE M-VECTOR H. */
/* X         - ON ENTRY X NEED NOT BE INITIALIZED. */
/*             ON EXIT X WILL CONTAIN THE SOLUTION VECTOR */
/*             (IF IERR=0). */
/* XNORM     - ON EXIT RNORM CONTAINS THE EUCLIDEAN NORM OF */
/*             THE SOLUTION VECTOR X. */
/* W( )      - AN (N+1)*(M+2)+2*M - ARRAY OF WORKING SPACE. */
/* INDEX( )  - AN INTEGER WORKING ARRAY OF LEANGTH AT */
/*             LEAST M. */
/* IERR      - THIS IS A DIAGNOSTICAL PARAMETER USED AS A */
/*             SUCCESS-FAILURE FLAG WITH  MEANINGS: */
/*              0 - THE SOLUTION HAS BEEN COMPUTED */
/*                  SUCCESSFULLY. */
/*              1 - THE SYSTEM HAS NO SOLUTION. */
/*             65 - THE DIMENSIONS OF THE PROBLEM ARE BAD. */
/*  EXTERNAL SUBROUTINES: */
/*           ALN1R  (NONNEGATIVE LIST SQUARES), */
/*           ALN1R4 (COMPUTE DIFFERENCE DIFF=X-Y) */

/* ********************************************************* */

    /* Parameter adjustments */
    --index;
    --h__;
    --x;
    g_dim1 = *mdg;
    g_offset = g_dim1 + 1;
    g -= g_offset;
    --w;

    /* Function Body */
    if (*n <= 0) {
        goto L120;
    }
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
/* L10: */
        x[j] = zero;
    }
    *xnorm = zero;
    if (*m <= 0) {
        goto L110;
    }

/*    THE DECLARED DIMENSION OF W MUST BE AT LEAST */
/*               (N+1)*(M+2)+2*M */

/*   FIRST (N+1)*M LOCKS OF W = MATRIX E FOR PROBLEM NNLS */
/*    NEXT     N+1 LOCKS OF W = VECTOR F FOR PROBLEM NNLS */
/*    NEXT     N+1 LOCKS OF W = VECTOR Z FOR PROBLEM NNLS */
/*    NEXT       M LOCKS OF W = VECTOR Y FOR PROBLEM NNLS */
/*    NEXT       M LOCKS OF W = VECTOR WDUAL FOR NNLS */
/*     COPY G**T INTO FIRST N ROWS AND M COLUMNS OF E */
/*     COPY H**T INTO ROW N+1 OF E */

    iw = 0;
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            ++iw;
/* L20: */
            w[iw] = g_ref(j, i__);
        }
        ++iw;
/* L30: */
        w[iw] = h__[j];
    }
    if__ = iw + 1;
/*     STORE N ZEROS FOLLOWED BY A ONE INTO F */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        ++iw;
        w[iw] = zero;
/* L40: */
    }
    w[iw + 1] = one;

    np1 = *n + 1;
    iz = iw + 2;
    iy = iz + np1;
    iwdual = iy + *m;

    aln1r_c(&w[1], &np1, &np1, m, &w[if__], &w[iy], &rnorm, &w[iwdual], &w[iz],
             &index[1], ierr);
/*     USE THE FOLLOWING RETURN IF UNSUCCESSFUL IN NNLS */
    if (*ierr != 0) {
        return 0;
    }
    if (rnorm <= 0.f) {
        goto L130;
    } else {
        goto L50;
    }
L50:
    fac = one;
    iw = iy - 1;
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        ++iw;
/*     HERE WE ARE USING THE SOLUTION VECTOR Y */
        fac -= h__[i__] * w[iw];
/* L60: */
    }

    r__1 = one + fac;
    if ((real)aln1r4_c(&r__1, &one) <= 0.f) {
        goto L130;
    } else {
        goto L70;
    }
L70:
    fac = one / fac;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        iw = iy - 1;
        i__2 = *m;
        for (i__ = 1; i__ <= i__2; ++i__) {
            ++iw;
/*     HERE WE ARE USING THE SOLUTION VECTOR Y */
            x[j] += g_ref(i__, j) * w[iw];
/* L80: */
        }
        x[j] *= fac;
/* L90: */
    }
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
/* Computing 2nd power */
        r__1 = x[j];
        *xnorm += r__1 * r__1;
/* L100: */
    }
    *xnorm = (real)sqrt(*xnorm);
/*     SUCCESSFUL RETURN */
L110:
    *ierr = 0;
    return 0;
/*     ERROR RETURN      N.LE.0 */
L120:
    *ierr = 65;
    return 0;
/*     RETURNING WITH CONSTRAINS NOT COMPATIBLE */
L130:
    *ierr = 1;
    return 0;
} /* ald1r_c */

#undef g_ref
