/* aln1r.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__0 = 0;
static integer c__2 = 2;

/* Subroutine */ int aln1r_c(real *a, integer *mda, integer *m, integer *n,
        real *b, real *x, real *rnorm, real *w, real *zz, integer *index, 
        integer *ierr)
{
    /* Initialized data */

    static real factor = .01f;
    static real two = 2.f;
    static real zero = 0.f;

    /* Format strings */
    static char fmt_200[] = "";
    static char fmt_320[] = "";

    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer iter;
    static real wmax;
    static integer next, i__, j, l;
    static real t, alpha;
    extern /* Subroutine */ int aln1r1_c(integer *, integer *, integer *,
            integer *, real *, integer *, real *, real *, integer *,
            integer *, integer *);
    static real asave;
    extern /* Subroutine */ int aln1r2_c(real *, real *, real *, real *,
            real *);
    extern real aln1r4_c(real *, real *);
    extern /* Subroutine */ int aln1r3_c(real *, real *, real *, real *);
    static integer itmax, izmax, nsetp;
    static real dummy, unorm, ztest, cc;
    static integer ii, jj, ip;
    static real sm;
    static integer iz, jz;
    static real up, ss;
    static integer iz1, iz2, npp1;

    /* Assigned format variables */
    static char *next_fmt;

#define a_ref(a_1,a_2) a[(a_2)*a_dim1 + a_1]

/* ******************************************************* */

/*    PURPOSE: *****NONNEGATIVE LEAST SQUARES*********** */

/*  GIVEN AN M BY N  MATRIX  .A. AND  AN  M-VECTOR .B. */
/*  COMPUTE  AN  N-VECTOR .X.  WHICH SOLVES THE LEAST */
/*  SQUARES PROBLEM: */
/*          A * X =  B     SUBJECT TO X.GE.0 */

/*  SOURCE:LAWSON C.L.,HANSON R.J. 'SOLVING LEAST SQUARES */
/*  PROBLEM' , PRENTICE-HALL INC.,ENGLEWOOD CLIFFS,NEW */
/*  JERSEY, 1974. */

/*    PARAMETERS: */
/* A,MDA,M,N - MDA IS THE FIRST DIMENSIONING PARAMETER FOR */
/*             THE ARRAY .A( ).  ON ENTRY A( ) CONTAINS THE */
/*             M BY N MATRIX .A.  ON EXIT A( ) CONTAINS THE */
/*             PRODUCT MATRIX .Q*A.,WHERE Q IS AN M BY M */
/*             ORTHOGONAL MATRIX GENERATED IMPLICITLY BY */
/*             THIS SUBROUTINE. */
/* B         - ON ENTRY B CONTAINS THE M-VECTOR B. */
/*             ON EXIT B CONTAINS Q*B. */
/* X         - ON ENTRY X NEED NOT BE INITIALIZED. */
/*             ON EXIT X WILL CONTAIN THE SOLUTION VECTOR. */
/* RNORM     - ON EXIT RNORM CONTAINS THE EUCLIDEAN NORM OF */
/*             THE RESIDUAL VECTOR. */
/* W( )      - AN N-ARRAY OF WORKING SPACE.  ON EXIT W( ) */
/*             WILL CONTAIN THE DUAL SOLUTION VECTOR.  W */
/*             WILL SATISFY      W(I)=0. */
/*             FOR ALL I IN SET P AND W(I) .LE. 0. */
/*             FOR ALL I IN SET Z. */
/* ZZ( )     - AN M-ARRAY OF WORKING SPACE. */
/* INDEX( )  - AN INTEGER WORKING ARRAY OF LEANGTH AT */
/*             LEAST N. */
/*             ON EXIT THE CONTENTS OF THIS ARRAY DEFINE */
/*             THE SETS  P AND  Z AS FOLLOWS... */
/*                     INDEX(1) THRU INDEX(NSETP) = SET P. */
/*                     INDEX(IZ1) THRU INDEX(IZ2) =SET Z. */
/*                     IZ1 = NSETP + 1 = NPP1 */
/*                     IZ2 = N . */
/* IERR      - THIS IS A DIAGNOSTICAL PARAMETER USED AS A */
/*             SUCCESS-FAILURE FLAG WITH MEANINGS: */
/*              0 - THE SOLUTION HAS BEEN COMPUTED */
/*                  SUCCESSFULLY. */
/*             65 - THE DIMENSIONS OF THE PROBLEM ARE BAD. */
/*             66 - ITERATION COUNT EXCEEDED  MORE THAN 3*N */
/*                  ITERATIONS. */
/*  EXTERNAL SUBROUTINES: */
/*           ALN1R1 (HOUSEHOLDER TRANSFORMATION), */
/*           ALN1R2 (COMPUTATION OF GIVENS ORTHOGONAL */
/*                   ROTATION MATRIX), */
/*           ALN1R3 (APPLICATION OF GIVENS MATRIX), */
/*           ALN1R4 (COMPUTE DIFFERENCE DIFF=X-Y) */

/* ********************************************************* */

    /* Parameter adjustments */
    --zz;
    --b;
    --index;
    --w;
    --x;
    a_dim1 = *mda;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    *ierr = 0;
    if (*m > 0 && *n > 0) {
        goto L10;
    }
    *ierr = 65;
    goto L450;
L10:
    iter = 0;
    itmax = *n * 3;

/*    INITIALIZE THE ARRAYS  INDEX( ) AND X( ) . */

    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        x[i__] = zero;
/* L20: */
        index[i__] = i__;
    }
    iz2 = *n;
    iz1 = 1;
    nsetp = 0;
    npp1 = 1;

/* *************** MAIN LOOP BEGINS THERE **************** */

L30:

/*   QUIT ALL COEFFICIENTS ARE ALREADY IN THE SOLUTION. */
/*   OR IF  M  COLS OF  A  HAVE BEEN TRIANGULARIZED. */

    if (iz1 > iz2 || nsetp >= *m) {
        goto L350;
    }

/*   COMPUTE COMPONENTS OF THE DUAL (NEGATIVE GRADIENT) */
/*   VECTOR W( ) . */

    i__1 = iz2;
    for (iz = iz1; iz <= i__1; ++iz) {
        j = index[iz];
        sm = zero;
        i__2 = *m;
        for (l = npp1; l <= i__2; ++l) {
/* L40: */
            sm += a_ref(l, j) * b[l];
        }
/* L50: */
        w[j] = sm;
    }

/* ************* FIND LARGEST POSITIVE  W(J) . ********* */

L60:
    wmax = zero;
    i__1 = iz2;
    for (iz = iz1; iz <= i__1; ++iz) {
        j = index[iz];
        if (w[j] <= wmax) {
            goto L70;
        }
        wmax = w[j];
        izmax = iz;
L70:
        ;
    }

/*  IF  WMAX .LE. 0   GO TO TERMINATION . */
/*  THIS INDICATES SATISFACTION OF THE KUHN-TUCKER */
/*  CONDITIONS . */

    if (wmax <= 0.f) {
        goto L350;
    } else {
        goto L80;
    }
L80:
    iz = izmax;
    j = index[iz];

/*  THE SIGN OF  W(J)  IS O.K. FOR J TO BE MOVED TO SET P. */
/*  BEGIN THE TRANSFORMATION AND CHECK NEW DIAGONAL ELEMENT */
/*  TO AVOID NEAR LINEAR DEPENDECE . */

    asave = a_ref(npp1, j);
    i__1 = npp1 + 1;
    aln1r1_c(&c__1, &npp1, &i__1, m, &a_ref(1, j), &c__1, &up, &dummy, &c__1, &
            c__1, &c__0);
    unorm = zero;
    if (nsetp == 0) {
        goto L100;
    }
    i__1 = nsetp;
    for (l = 1; l <= i__1; ++l) {
/* L90: */
/* Computing 2nd power */
        r__1 = a_ref(l, j);
        unorm += r__1 * r__1;
    }
L100:
    unorm = (real)sqrt(unorm);
    r__2 = unorm + (r__1 = a_ref(npp1, j), abs(r__1)) * factor;
    if ((real)aln1r4_c(&r__2, &unorm) <= 0.f) {
        goto L130;
    } else {
        goto L110;
    }

/*  COL J IS SUFFICIENTLY INDEPENDENT. COPY B INTO ZZ. */
/*  UPDATE ZZ AND SOLVE FOR ZTEST ( -PROPOSED NEW VALUE FOR */
/*  X(J)) . */

L110:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L120: */
        zz[l] = b[l];
    }
    i__1 = npp1 + 1;
    aln1r1_c(&c__2, &npp1, &i__1, m, &a_ref(1, j), &c__1, &up, &zz[1], &c__1,
            &c__1, &c__1);
    ztest = zz[npp1] / a_ref(npp1, j);

/* *************** SEE IF ZTEST IS POSITIVE ************ */

    if (ztest <= 0.f) {
        goto L130;
    } else {
        goto L140;
    }

/*  REJECT J AS A CANDIDATE TO BE MOVED FROM SET Z TO SET */
/*  P. RESTORE A(NPP1,J). SET W(J)=0.  AND LOOP BACK TO */
/*  TEST DUAL COEFFS AGAIN . */

L130:
    a_ref(npp1, j) = asave;
    w[j] = zero;
    goto L60;

/*  THE INDEX J = INDEX(IZ) HAS BEEN SELECTED TO BE MOVED */
/*  FROM SET Z TO SET P. UPDATE B. UPDATE INDICES> APPLY */
/*  HOUSEHOLDER TRANSFORMATIONS TO COLS IN NEW SET Z. */
/*  ZERO SUBDIAGONAL ELTS IN COL J. SET W(J) = 0 . */

L140:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L150: */
        b[l] = zz[l];
    }
    index[iz] = index[iz1];
    index[iz1] = j;
    ++iz1;
    nsetp = npp1;
    ++npp1;
    if (iz1 > iz2) {
        goto L170;
    }
    i__1 = iz2;
    for (jz = iz1; jz <= i__1; ++jz) {
        jj = index[jz];
/* L160: */
        aln1r1_c(&c__2, &nsetp, &npp1, m, &a_ref(1, j), &c__1, &up,
                &a_ref(1,jj), &c__1, mda, &c__1);
    }
L170:
    if (nsetp == *m) {
        goto L190;
    }
    i__1 = *m;
    for (l = npp1; l <= i__1; ++l) {
/* L180: */
        a_ref(l, j) = zero;
    }
L190:
    w[j] = zero;

/* ******  SOLVE THE TRIANGULAR SYSTEM.  ************ */
/*  STORE THE SOLUTION TEMPORARILY IN ZZ( ) ******** */

    next = 0;
    next_fmt = fmt_200;
    goto L400;
L200:

/* ************** SECONDARY LOOP BEGINS HERE  ************ */

/*  ITERATION COUNTER . */

L210:
    ++iter;
    if (iter <= itmax) {
        goto L220;
    }
    *ierr = 66;
    goto L350;
L220:

/*  SEE IF ALL NEW CONSTRAINED COEFFS ARE FEASIBLE. */
/*  IF NOT COMPUTE ALPHA . */

    alpha = two;
    i__1 = nsetp;
    for (ip = 1; ip <= i__1; ++ip) {
        l = index[ip];
        if (zz[ip] <= 0.f) {
            goto L230;
        } else {
            goto L240;
        }

L230:
        t = -x[l] / (zz[ip] - x[l]);
        if (alpha <= t) {
            goto L240;
        }
        alpha = t;
        jj = ip;
L240:
        ;
    }

/*  IF ALL NEW CONSTRAINED COEFFS ARE FEASIBLE THEN */
/*  ALPHA WILL STILL = 2. IF SO EXIT FROM SECONDARY LOOP */
/*  TO MAIN LOOP . */

    if (alpha == two) {
        goto L330;
    }

/*  OTHERWISE USE ALPHA WHICH WILL BE BETWEEN 0. AND 1. TO */
/*  INTERPOLATE BETWEEN THE OLD X AND THE NEW ZZ . */

    i__1 = nsetp;
    for (ip = 1; ip <= i__1; ++ip) {
        l = index[ip];
/* L250: */
        x[l] += alpha * (zz[ip] - x[l]);
    }

/*  MODIFY A AND B AND THE INDEX ARRAYS TO MOVE */
/*  COEFFICIENT I  FROM SET  P  TO SET  Z . */

    i__ = index[jj];
L260:
    x[i__] = zero;
    if (jj == nsetp) {
        goto L290;
    }
    ++jj;
    i__1 = nsetp;
    for (j = jj; j <= i__1; ++j) {
        ii = index[j];
        index[j - 1] = ii;
        aln1r2_c(&a_ref(j - 1, ii), &a_ref(j, ii), &cc, &ss,
                &a_ref(j - 1, ii));
        a_ref(j, ii) = zero;
        i__2 = *n;
        for (l = 1; l <= i__2; ++l) {
            if (l != ii) {
                aln1r3_c(&cc, &ss, &a_ref(j - 1, l), &a_ref(j, l));
            }
/* L270: */
        }
/* L280: */
        aln1r3_c(&cc, &ss, &b[j - 1], &b[j]);
    }
L290:
    npp1 = nsetp;
    --nsetp;
    --iz1;
    index[iz1] = i__;

/*  SEE IF REMAINING COEFFS IN THE SET P ARE FEASIBLE. */
/*  THEY SHOULD BE BECAUSE OF THE WAY ALPHA WAS DETERMINED. */
/*  IF ANY ARE INFEASIBLE IT IS DUE TO ROUND-OFF ERRORS. */
/*  ANY THAT ARE NONPOSITIVE WILL BE SET TO ZERO AND MOVED */
/*  FROM SET  P  TO SET  Z . */

    i__1 = nsetp;
    for (jj = 1; jj <= i__1; ++jj) {
        i__ = index[jj];
        if (x[i__] <= 0.f) {
            goto L260;
        } else {
            goto L300;
        }
L300:
        ;
    }

/*  COPY  B( ) INTO ZZ( ). THEN SOLVE AGAIN AND LOOP BACK. */

    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L310: */
        zz[i__] = b[i__];
    }
    next = 1;
    next_fmt = fmt_320;
    goto L400;
L320:
    goto L210;

/* ********** END OF SECONDARY LOOP  ****************** */

L330:
    i__1 = nsetp;
    for (ip = 1; ip <= i__1; ++ip) {
        i__ = index[ip];
/* L340: */
        x[i__] = zz[ip];
    }

/*  ALL NEW COEFFS ARE POSITIVE. LOOP BACK TO BEGINNING . */

    goto L30;

/* ************** END OF MAIN LOOP  **************** */

/*  COME TO HERE FOR TERMINATION . */
/*  COMPUTE THE NORM OF THE FINAL RESIDUAL VECTOR . */

L350:
    sm = zero;
    if (npp1 > *m) {
        goto L370;
    }
    i__1 = *m;
    for (i__ = npp1; i__ <= i__1; ++i__) {
/* L360: */
/* Computing 2nd power */
        r__1 = b[i__];
        sm += r__1 * r__1;
    }
    goto L390;
L370:
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
/* L380: */
        w[j] = zero;
    }
L390:
    *rnorm = (real)sqrt(sm);
    goto L450;

/*  THE FOLLOWING BLOCK OF CODE IS USED AS INTERNAL */
/*  SUBROUTINE TO SOLVE THE TRIANGULAR SYSTEM, PUTTING */
/*  THE SOLUTION IN ZZ( ) . */

L400:
    i__1 = nsetp;
    for (l = 1; l <= i__1; ++l) {
        ip = nsetp + 1 - l;
        if (l == 1) {
            goto L420;
        }
        i__2 = ip;
        for (ii = 1; ii <= i__2; ++ii) {
/* L410: */
            zz[ii] -= a_ref(ii, jj) * zz[ip + 1];
        }
L420:
        jj = index[ip];
/* L430: */
        zz[ip] /= a_ref(ip, jj);
    }
    switch (next) {
        case 0: goto L200;
        case 1: goto L320;
    }
L450:
    return 0;
} /* aln1r_c */

#undef a_ref
